#ifndef OMNETPP_FAKE_EVENTMANAGER_H_
#define OMNETPP_FAKE_EVENTMANAGER_H_

#include <omnetpp.h>

#include <sstmac/common/eventmanager.h>
#include <node/processor/eventhandlerpod.h>
#include <node_m.h>

namespace sstmac
{
  namespace omnetpp
  {

    class fakeeventmanager : public sstmac::eventmanager
    {
    protected:
      cSimpleModule *parent_;

      fakeeventmanager(cSimpleModule *p) :
        parent_(p)
      {

      }

      timestamp now_;

    public:

      static boost::intrusive_ptr<fakeeventmanager>
      construct(cSimpleModule *p)
      {
        boost::intrusive_ptr<fakeeventmanager> ret(new fakeeventmanager(p));
        return ret;
      }

      virtual void
      clear(const sstmac::timestamp &zero_time = sstmac::timestamp(0))
      {

      }

      virtual void
      register_finish(ptr_type::ptr p)
      {
        //parent_->finishes_.push_back(p);
      }

      virtual void
      cancel_all_messages(const eventhandler::ptr &handler)
      {

      }

      virtual void
      run()
      {

      }

      virtual void
      step()
      {

      }

      virtual const sstmac::timestamp&
      now()
      {

        now_ = timestamp(simTime().dbl());
        return now_;
      }


      virtual void
      schedule(const timestamp& start_time,
               const ::sstmac::event::ptr& event)
      {
          eventpod epod(event);

          EventWrapperMsg* emsg = new EventWrapperMsg();
          emsg->setEvent(epod);

          double d = start_time.sec();
          simtime_t time(d);

          //have to check for a conversion error
          if (time < simTime())
            parent_->scheduleAt(simTime(), emsg);
          else
            parent_->scheduleAt(time, emsg);
      }

    };

  }
}

#endif
