/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/hardware/network/switches/networkswitch.h>

namespace sstmac
{
  namespace hw
  {

    debug networkswitch::dbg_;

    ImplementFactory(networkswitch);

    injector::ptr
    networkswitch::get_injector(sim_parameters::ptr params, int c)
    {

      if (ij_.find(c) == ij_.end())
        {
          ij_[c] = get_new_injector(params);

        }

      return ij_[c];
    }

    ejector::ptr
    networkswitch::get_ejector(sim_parameters::ptr params, int c)
    {
      if (ej_.find(c) == ej_.end())
        {
          ej_[c] = get_new_ejector(params);
          outports_[EJECT_PORT][c] = ej_[c];
        }

      return ej_[c];
    }
  }
}
