/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_HARDWARE_NETWORK_SWITCHES_ROUTING_DRAGONFLYROUTER_CONGESTION_H_INCLUDED
#define SSTMAC_HARDWARE_NETWORK_SWITCHES_ROUTING_DRAGONFLYROUTER_CONGESTION_H_INCLUDED

#include <sstmac/hardware/network/topology/dragonflyrouter.h>

namespace sstmac
{
  namespace hw
  {

    class dragonflyrouter_congestion : public dragonflyrouter
    {

    protected:
      dragonflyrouter_congestion()
      {

      }

      virtual bool
      needs_congestion_info() const
      {
        return true;
      }

    public:
      typedef boost::intrusive_ptr<dragonflyrouter_congestion> ptr;

      static ptr
      construct(sim_parameters::ptr params)
      {
        return ptr(new dragonflyrouter_congestion());
      }

      virtual void
      route(sstmac::hw::routing_info::ptr to, int &dim, int &dir);

      virtual
      ~dragonflyrouter_congestion()
      {
      }

    };

  }
}
#endif
