/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_HARDWARE_NETWORK_TOPOLOGY_FAKE_TOPOLOGY_H_INCLUDED
#define SSTMAC_HARDWARE_NETWORK_TOPOLOGY_FAKE_TOPOLOGY_H_INCLUDED

#include <sstmac/hardware/network/topology/topology.h>

namespace sstmac
{
  namespace hw
  {

    class fake_topology : public topology
    {
    public:
      typedef boost::intrusive_ptr<fake_topology> ptr;
      virtual int64_t
      diameter() const
      {
        throw "switchinterconnect::fake_topology::diameter() - don't call this";
      }

      static ptr
      construct()
      {
        return ptr(new fake_topology());
      }
    };
  }
}

#endif
