/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_HARDWARE_NETWORK_SWTICHES_ROUTING_FATTREEROUTER_CONGESTION_H_INCLUDED
#define SSTMAC_HARDWARE_NETWORK_SWTICHES_ROUTING_FATTREEROUTER_CONGESTION_H_INCLUDED

#include <sstmac/hardware/network/topology/fattreerouter.h>
#include <sstmac/common/messages/sst_message.h>
#include <math.h>

namespace sstmac
{
  namespace hw
  {

    class fattreerouter_congestion : public virtual fattreerouter
    {
    public:
      typedef boost::intrusive_ptr<fattreerouter_congestion> ptr;

      static ptr
      construct(sim_parameters::ptr params)
      {
        return ptr(new fattreerouter_congestion());
      }

      virtual void
      route(routing_info::ptr to, int &dim, int &dir);

      virtual
      ~fattreerouter_congestion()
      {
      }

      virtual bool
      needs_congestion_info() const
      {
        return true;
      }

      virtual std::string
      to_string() const
      {
        return "fattreerouter_congestion";
      }

    protected:

      fattreerouter_congestion()
      {

      }

    };

  }
}
#endif
