/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */
#ifndef SSTMAC_SOFTWARE_LIBRARIES_COMPUTE_SSTMAC_COMPUTE_H_INCLUDED
#define SSTMAC_SOFTWARE_LIBRARIES_COMPUTE_SSTMAC_COMPUTE_H_INCLUDED

#ifdef __cplusplus
extern "C"
{
#endif

  void
  SSTMAC_compute(double seconds);

  void
  SSTMAC_compute_block_read(long long bytes);


  // ----------- compute loop functions ------------- //
  void
  SSTMAC_compute_loop(int from, int to, int numlines);

  void
  SSTMAC_compute_loop2(int from1, int to1, int from2, int to2, int numlines);

  void
  SSTMAC_compute_loop3(int from1, int to1, int from2, int to2, int from3, int to3,
      int numlines);

  void
  SSTMAC_compute_loop4(int from1, int to1, int from2, int to2, int from3, int to3,
      int from4, int to4, int numlines);

  // --------------------------------------------------- //

#ifdef __cplusplus
}
#endif

#endif
