/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009-2011 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#include "user_shmemapp_c.h"

extern "C" int
user_skeleton_main(int argc, char **argv);

namespace sstmac
{
  namespace sw
  {
    namespace shmem
    {
      SSTRegister("user_shmemapp_c", ::sstmac::sw::app, user_shmemapp_c);

      void
      user_shmemapp_c::skeleton_main()
      {
        std::cout << "started shmem cxx wrapper \n";
        user_skeleton_main(get_argc(), get_argv());
      }
    }

  } //end namespace sw
} //end namespace sstmac


