/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009-2011 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#include "user_shmemapp_cxx.h"

int
user_skeleton_main(int argc, char **argv);
void
consume_parameters(const sstmac::sim_parameters::ptr &params);

namespace sstmac
{
  namespace sw
  {
    namespace shmem
    {
      SSTRegister("user_shmemapp_cxx", ::sstmac::sw::app, user_shmemapp_cxx,
                  "default application for linking to external C++ skeleton apps");

      void
      user_shmemapp_cxx::skeleton_main()
      {
        std::cout << "started shmem cxx wrapper \n";
        user_skeleton_main(get_argc(), get_argv());
      }

      void
      user_shmemapp_cxx::consume_params(
          const sstmac::sim_parameters::ptr &params)
      {
        consume_parameters(params);
      }

    }
  } //end namespace sw
} //end namespace sstmac


