/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#include <sstmac-eiger/eigermessage.h>

namespace sstmac {

	eigermessage::eigermessage(const std::map<std::string,double> &input_params, const std::string &model_fname)
		: sst_message(EIGER), 
          library_message(""),
          input_params_(input_params), model_fname_(model_fname)
	{}

	eigermessage::ptr
	eigermessage::construct(const std::map<std::string,double> &input_params, const std::string &model_fname)
	{
		eigermessage::ptr retval(new eigermessage(input_params, model_fname));

		return retval;
	}

} // end of namespace sstmac

